// Mircea Digulescu - Bucuresti, ROMANIA

#include <fstream.h>

#define MAX 153

ifstream in("arbore.in");
ofstream out("arbore.out");

extern unsigned _stklen = 102400;
extern unsigned _hplen = 0;

int n,p;

struct node
 {
  int i;
  node *next;
 } *fii[MAX];

int tata[MAX];

inline void QADD(int i, int j)
 {
  node *n=new node;
  n->i=j;
  n->next=fii[i];
  fii[i]=n;
 }

#define INF 32000

unsigned int c[151][151];

void Post(int i)
 {
  node *t = fii[i];
  c[i][0]=0;
  if(!t) {c[i][0]=1;c[i][1]=0;return;}
  while(t)
   {
    Post(t->i);
    for(int j=p;j>=0;j--)
     {
     c[i][j] += c[t->i][0];
     for(int k=1;k<=j;k++) if(c[i][j] > c[i][j-k] + c[t->i][k]) c[i][j]=c[i][j-k] + c[t->i][k];
     }
    t=t->next;
   }
  for(int j=p;j>=0;j--) c[i][j] = c[i][j-1];
  c[i][0]=1;
 }

char nr[MAX];

int FindRoot()
 {
  for(int i=0;i<n;i++)
   {
    node *t=fii[i];
    while(t)
     {
      nr[t->i]=1;
      t=t->next;
     }
   }
  for(i=0;i<n;i++) if(!nr[i]) return i;
  return 0;
 }

void main()
 {
  in>>n>>p;
  int a,b;
  for(int i=1;i<n;i++)
   {
    in>>a>>b; a--;b--;
    QADD(a,b);
   }
  for(i=0;i<n;i++)
   for(int j=0;j<n;j++) c[i][j]=INF;
  int r = FindRoot();
  Post(r);
  int min = 300;
  for(i=0;i<n;i++) if(c[i][p]<min) min=c[i][p];
  min++;
  if(c[r][p]<min) min=c[r][p];
  if(min<n) out<<min;
 }