{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 60384,0,655360}

Program PATRAT;

const filein='PATRAT.IN';
      fileout='PATRAT.OUT';
      MAXN=20;

      fasie2:array[1..6,1..2] of integer=
      (
      (1,1),
      (1,2),
      (2,2),
      (3,3),
      (3,4),
      (4,4)
      );

      fasie3:array[1..6,1..3] of integer=
      (
      (1,1,2),
      (1,2,2),
      (3,3,4),
      (3,4,4),
      (5,5,6),
      (5,6,6)
      );

var fin,fout:text;
    i,j,k,m,n,p,q,npi,lls,llj,ccs,ccd:integer;
    mat:array[1..7,1..7] of integer;
    pp:array[1..6*MAXN+1,1..6*MAXN+1] of integer;

procedure print;
begin

mat[p,q]:=0;
for i:=lls to llj do
  for j:=ccs to ccd do
    if (mat[i-lls+1,j-ccs+1]>0) then
      pp[i,j]:=npi+mat[i-lls+1,j-ccs+1]
    else
      pp[i,j]:=0;

assign(fout,fileout);
rewrite(fout);

for i:=1 to 6*n+1 do
  begin
    for j:=1 to 6*n do
      write(fout,pp[i,j],' ');
    writeln(fout,pp[i,6*n+1]);
  end;

close(fout);
halt(0);
end;

procedure back(niv:integer);
var ii,jj:integer;
    ok:boolean;
begin
if (niv=17) then
  begin
    print;
  end
else
  begin
    ok:=true;
    for ii:=1 to 7 do
      begin
        for jj:=1 to 7 do
          if (mat[ii,jj]=0) then
            begin
              ok:=false;
              break;
            end;
        if (not ok) then break;
      end;
    if (ii+1<=7) and (jj+1<=7) and (mat[ii,jj+1]=0) and (mat[ii+1,jj+1]=0)
    then
      begin
        mat[ii,jj]:=niv;
        mat[ii,jj+1]:=niv;
        mat[ii+1,jj+1]:=niv;

        back(niv+1);

        mat[ii,jj]:=0;
        mat[ii,jj+1]:=0;
        mat[ii+1,jj+1]:=0;
      end;

    if (ii+1<=7) and (jj+1<=7) and (mat[ii+1,jj]=0) and (mat[ii+1,jj+1]=0)
    then
      begin
        mat[ii,jj]:=niv;
        mat[ii+1,jj]:=niv;
        mat[ii+1,jj+1]:=niv;

        back(niv+1);

        mat[ii,jj]:=0;
        mat[ii+1,jj]:=0;
        mat[ii+1,jj+1]:=0;
      end;

    if (jj-1>0) and (ii+1<=7) and (mat[ii+1,jj-1]=0) and (mat[ii+1,jj]=0)
    then
      begin
        mat[ii,jj]:=niv;
        mat[ii+1,jj-1]:=niv;
        mat[ii+1,jj]:=niv;

        back(niv+1);

        mat[ii,jj]:=0;
        mat[ii+1,jj-1]:=0;
        mat[ii+1,jj]:=0;
      end;

    if (ii+1<=7) and (jj+1<=7) and (mat[ii,jj+1]=0) and (mat[ii+1,jj]=0)
    then
      begin
        mat[ii,jj]:=niv;
        mat[ii+1,jj]:=niv;
        mat[ii,jj+1]:=niv;

        back(niv+1);

        mat[ii,jj]:=0;
        mat[ii+1,jj]:=0;
        mat[ii,jj+1]:=0;
      end;
  end;
end;

procedure fill(ls,lj,cs,cd,nn:integer);
begin
if (nn=1) then
  begin
    fillchar(mat,sizeof(mat),0);
    p:=p-ls+1;
    q:=q-cs+1;
    mat[p,q]:=-1;

    lls:=ls; llj:=lj;
    ccs:=cs; ccd:=cd;

    back(1);
  end
else
  begin
    if (ls+p-1<=ls+6*(nn-1)) then
      begin
        if (cs+q-1<=cs+6*(nn-1)) then
          begin
            { STANGA-SUS }

            for j:=cs to cd-3 do
              begin
                if (j>cd-3) then break;
                for k:=j to j+1 do
                  for i:=lj-5 to lj do
                    pp[i,k]:=npi+fasie2[i-lj+6,k-j+1];

                npi:=npi+4;
                inc(j);
              end;

            for j:=cd-2 to cd do
              for i:=lj-5 to lj do
                pp[i,j]:=npi+fasie3[i-lj+6,j-cd+3];
            npi:=npi+6;

            for i:=ls to lj-9 do
              begin
                if (i>lj-9) then break;
                for k:=i to i+1 do
                  for j:=cd-5 to cd do
                    pp[k,j]:=npi+fasie2[j-cd+6,k-i+1];

                npi:=npi+4;
                inc(i);
              end;

            for i:=lj-8 to lj-6 do
              for j:=cd-5 to cd do
                pp[i,j]:=npi+fasie3[j-cd+6,i-lj+9];
            npi:=npi+6;

            fill(ls,ls+6*(nn-1),cs,cs+6*(nn-1),nn-1);
          end
        else
          begin
            { DREAPTA-SUS }

            for j:=cs to cd-3 do
              begin
                if (j>cd-3) then break;
                for k:=j to j+1 do
                  for i:=lj-5 to lj do
                    pp[i,k]:=npi+fasie2[i-lj+6,k-j+1];

                npi:=npi+4;
                inc(j);
              end;

            for j:=cd-2 to cd do
              for i:=lj-5 to lj do
                pp[i,j]:=npi+fasie3[i-lj+6,j-cd+3];
            npi:=npi+6;

            for i:=ls to lj-9 do
              begin
                if (i>lj-9) then break;
                for k:=i to i+1 do
                  for j:=cs to cs+5 do
                    pp[k,j]:=npi+fasie2[j-cs+1,k-i+1];

                npi:=npi+4;
                inc(i);
              end;

            for i:=lj-8 to lj-6 do
              for j:=cs to cs+5 do
                pp[i,j]:=npi+fasie3[j-cs+1,i-lj+9];
            npi:=npi+6;

            fill(ls,ls+6*(nn-1),cs+6,cd,nn-1);
          end;
      end
    else
      begin
        if (cs+q-1<=cs+6*(nn-1)) then
          begin
            { STANGA-JOS }

            for j:=cs to cd-3 do
              begin
                if (j>cd-3) then break;
                for k:=j to j+1 do
                  for i:=ls to ls+5 do
                    pp[i,k]:=npi+fasie2[i-ls+1,k-j+1];

                npi:=npi+4;
                inc(j);
              end;

            for j:=cd-2 to cd do
              for i:=ls to ls+5 do
                pp[i,j]:=npi+fasie3[i-ls+1,j-cd+3];
            npi:=npi+6;

            for i:=ls+6 to lj-4 do
              begin
                if (i>lj-4) then break;
                for k:=i to i+1 do
                  for j:=cd-5 to cd do
                    pp[k,j]:=npi+fasie2[j-cd+6,k-i+1];

                npi:=npi+4;
                inc(i);
              end;

            for i:=lj-2 to lj do
              for j:=cd-5 to cd do
                pp[i,j]:=npi+fasie3[j-cd+6,i-lj+3];
            npi:=npi+6;

            fill(ls+6,lj,cs,cs+6*(nn-1),nn-1);
          end
        else
          begin
            { DREAPTA-JOS }

            for j:=cs to cd-3 do
              begin
                if (j>cd-3) then break;
                for k:=j to j+1 do
                  for i:=ls to ls+5 do
                    pp[i,k]:=npi+fasie2[i-ls+1,k-j+1];

                npi:=npi+4;
                inc(j);
              end;

            for j:=cd-2 to cd do
              for i:=ls to ls+5 do
                pp[i,j]:=npi+fasie3[i-ls+1,j-cd+3];
            npi:=npi+6;

            for i:=ls+6 to lj-4 do
              begin
                if (i>lj-4) then break;
                for k:=i to i+1 do
                  for j:=cs to cs+5 do
                    pp[k,j]:=npi+fasie2[j-cs+1,k-i+1];

                npi:=npi+4;
                inc(i);
              end;

            for i:=lj-2 to lj do
              for j:=cs to cs+5 do
                pp[i,j]:=npi+fasie3[j-cs+1,i-lj+3];
            npi:=npi+6;

            fill(ls+6,lj,cs+6,cd,nn-1);
          end;
      end;
  end;
end;

begin
assign(fin,filein);
reset(fin);
readln(fin,n);
readln(fin,p,q);
close(fin);

fillchar(pp,sizeof(pp),0);

npi:=0;
fill(1,6*n+1,1,6*n+1,n);
end.