{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program ZERO;

const filein='ZERO.IN';
      fileout='ZERO.OUT';
      MAXL=20;
      baza=1000;
      vmax=999;
      avans=2;

type NMARE=array[0..22] of integer;

var fin,fout:text;
    nnp:array[1..MAXL,0..MAXL] of NMARE;
    nnq:array[1..MAXL,0..MAXL,0..1] of NMARE;
    i,j,k,l,b,p,q:integer;
    naux,naux2,np,nq:NMARE;

procedure adunanm(n1,n2:NMARE; var rez:NMARE);
var r,co:integer;
begin
if (n1[0]>n2[0]) then
  r:=n1[0]
else
  r:=n2[0];

fillchar(rez,sizeof(NMARE),0);

for co:=1 to r+avans do
  rez[co]:=n1[co]+n2[co];
for co:=1 to r+avans do
  if (rez[co]>vmax) then
    begin
      rez[co+1]:=rez[co+1]+(rez[co] div baza);
      rez[co]:=rez[co] mod baza;
    end;

for co:=r+avans downto 1 do
  if (rez[co]>0) then
    begin
      rez[0]:=co;
      break;
    end;
end;

procedure inmulnm(n1:NMARE;x:integer; var rez:NMARE);
var r,co:integer;
begin

fillchar(rez,sizeof(rez),0);
for co:=1 to n1[0] do
  rez[co]:=n1[co]*x;
for co:=1 to n1[0]+avans do
  if (rez[co]>vmax) then
    begin
      rez[co+1]:=rez[co+1]+(rez[co] div baza);
      rez[co]:=rez[co] mod baza;
    end;

for co:=n1[0]+avans downto 1 do
  if (rez[co]>0) then
    begin
      rez[0]:=co;
      break;
    end;
end;

begin
assign(fin,filein);
reset(fin);
readln(fin,l,b,p,q);
close(fin);

{ P }

fillchar(nnp,sizeof(nnp),0);
nnp[1,0][0]:=1;
nnp[1,0][1]:=b-1;

for i:=2 to l do
  begin
    for j:=0 to p do
      begin
        inmulnm(nnp[i-1,j],b-1,naux);
        adunanm(naux,nnp[i,0],naux2);
        move(naux2,nnp[i,0],sizeof(NMARE));
      end;

    for j:=1 to p do
      move(nnp[i-1,j-1],nnp[i,j],sizeof(NMARE));
  end;

fillchar(np,sizeof(NMARE),0);

for j:=0 to p do
  begin
    adunanm(np,nnp[l,j],naux);
    move(naux,np,sizeof(NMARE));
  end;

{ END P }

{ Q }
fillchar(nnq,sizeof(nnq),0);
nnq[1,0,0][0]:=1;
nnq[1,0,0][1]:=b-1;

for i:=2 to l do
  begin
    for j:=0 to q-1 do
      begin
        inmulnm(nnq[i-1,j,0],b-1,naux);
        adunanm(naux,nnq[i,0,0],naux2);
        move(naux2,nnq[i,0,0],sizeof(NMARE));

        inmulnm(nnq[i-1,j,1],b-1,naux);
        adunanm(naux,nnq[i,0,1],naux2);
        move(naux2,nnq[i,0,1],sizeof(NMARE));
      end;

    for j:=1 to q-1 do
      begin
        move(nnq[i-1,j-1,0],nnq[i,j,0],sizeof(NMARE));
        move(nnq[i-1,j-1,1],nnq[i,j,1],sizeof(NMARE));
      end;

    adunanm(nnq[i-1,q-1,0],nnq[i-1,q-1,1],naux);
    move(naux,nnq[i,q,1],sizeof(NMARE));

    inmulnm(nnq[i-1,q,1],b-1,naux);
    adunanm(naux,nnq[i,0,1],naux2);
    move(naux2,nnq[i,0,1],sizeof(NMARE));

    for j:=q+1 to l-1 do
      begin
        move(nnq[i-1,j-1,1],nnq[i,j,1],sizeof(NMARE));

        inmulnm(nnq[i-1,j,1],b-1,naux);
        adunanm(naux,nnq[i,0,1],naux2);
        move(naux2,nnq[i,0,1],sizeof(NMARE));
      end;
  end;

fillchar(nq,sizeof(NMARE),0);
for i:=0 to l-1 do
  begin
    adunanm(nnq[l,i,1],nq,naux);
    move(naux,nq,sizeof(NMARE));
  end;

{ END Q }


assign(fout,fileout);
rewrite(fout);

write(fout,np[np[0]]);
for i:=np[0]-1 downto 1 do
  begin
    p:=baza div 10;
    while (p>0) do
      begin
        write(fout,(np[i] div p) mod 10);
        p:=p div 10;
      end;
  end;
writeln(fout);

write(fout,nq[nq[0]]);
for i:=nq[0]-1 downto 1 do
  begin
    p:=baza div 10;
    while (p>0) do
      begin
        write(fout,(nq[i] div p) mod 10);
        p:=p div 10;
      end;
  end;
writeln(fout);

close(fout);
end.
