{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

const
  MaxN= 1000;
  Max= 100;
type
  BigNr= Array[0.. Max] of Integer;

var
  N, K: Integer;
  A, B: BigNr;
  T: Array[0.. 1, 0.. Max] of BigNr;

procedure Init;
var F: Text;
begin
  Assign(F, 'EXP.IN');
  Reset(F);
  Read(F, N, K);
  Close(F);
end;

procedure Give(var A: BigNr; X: Integer);
begin
  A[0]:= 1;
  A[1]:= X;
end;

procedure Add(var A, B: BigNr);
var I, J, Carry: Integer;
begin
  Carry:= 0;
  J:= A[0];
  if B[0]> J then J:= B[0];

  Asm
    Les Si, A
    Les Di, B
    Mov Cx, J
    Xor Ax, Ax
@Next:
    Add Si, 2
    Add Di, 2
    Add Ax, [Si]
    Add Ax, [Di]
    Cmp Ax, 9
    Jbe @Else
    Sub Ax, 10
    Mov [Si], Ax
    Mov Ax, 1
    Dec Cx
    Jnz @Next
    Jmp @Done
@Else:
    Mov [Si], Ax
    Mov Ax, 0
    Dec Cx
    Jnz @Next
@Done:
    Mov [Carry], Ax
  end;
{
  For I:= 1 to J do
  begin
    Inc(Carry, A[I]+ B[I]);
    If Carry> 9 then
    begin
      A[I]:= Carry- 10;
      Carry:= 1;
    end else
    begin
      A[I]:= Carry;
      Carry:= 0;
    end;
  end;
}
  if A[0]< B[0] then A[0]:= B[0];
  if Carry> 0 then
  begin
    Inc(A[0]);
    A[ A[0] ]:= 1;
  end;
end;

procedure Calc;
var I, J: Integer;
begin
  For I:= 0 to K do
      Give(T[1, I], 1);
  For J:= 2 to N -1 do
      For I:= K downto 1 do
      begin
        Add(T[1, I], T[0, I]);
        Add(T[0, I], T[1, I -1]);
      end;
  Add(T[0, K], T[1, K]);
end;

procedure Outp;
var F: Text;
    I: Integer;
begin
  Assign(F, 'EXP.OUT');
  Rewrite(F);
  For I:= T[0, K, 0] downto 1 do
      Write(F, T[0, K, I]);
  Close(F);
end;

begin
  Init;
  Calc;
  Outp;
end.
