#include <stdio.h>
#include <stdlib.h>
#include <dos.h>

const int PMax = 20;
const int NMax = 10000;


int P, N;
int NE;

int Sol;
int ST[NMax+1];

long far* Timer;
long      TStop;


void ReadData()
{
	FILE* f = fopen("numere.in", "rt");
	fscanf(f, "%d %d", &P, &N);
	fclose(f);
}

int i, j, k, s, ss, f;

int BKT(int K)
{
	if ((*Timer) >= TStop) return 1;

	if (K > N)
	{
		ST[K] = ST[1];
		for (s = 0, i = 1; i <= NE+2; i++)
			s += ST[i];

		for (j = 2; j <= P; j++)
		{
			k = NE * (j-1) + j;
			for (ss = 0, i = 0; i < NE+2; i++)
				ss += ST[k+i];

			if (ss != s) return 0;
		}

		Sol = 1;
		return 1;
	}
	else
	{
		while (++ST[K] <= N)
		{
			f = 1;
			for (i = 1; i <= K-1; i++)
				if (ST[i] == ST[K])
					{ f = 0; break; }
			if (f)
			{
				ST[K+1] = 0;
				if (BKT(K+1))
					return 1;
			}
		}
	}
	return 0;
}

void Solve()
{
	Sol = 0;
	if (N % P == 0)
	{
		NE = N / P - 1;
		ST[1] = 0;
		BKT(1);
	}
}

void WriteData()
{
	FILE* f = fopen("numere.out", "wt");
	if (!Sol)
	{
		fprintf(f, "fara solutie");
	}
	else
	{
		fprintf(f, "%d\n", s);
		int i, j, k;
		for (j = 1; j <= P; j++)
		{
			k = NE * (j-1) + j;
			for (i = 0; i < NE+1; i++)
				fprintf(f, "%d ", ST[i+k]);
			fprintf(f, "%d\n", ST[NE+1+k]);
		}
	}
	fclose(f);
}

void main()
{
	Timer = (long far*)MK_FP(0x0000, 0x046C);
	TStop = (*Timer) + 105;

	ReadData();
	Solve();
	WriteData();
}