#include <stdio.h>
#include <values.h>
#include <dos.h>

const int NMax = 150;

int     N, P, R;
int far A[NMax+1][NMax+1];
int far M[NMax+1][NMax+1];
int     Min;

long far* Timer;
long      TStop;


void ReadData()
{
	int nr[NMax+1], i, I, J;

	FILE* f = fopen("arbore.in", "rt");
	fscanf(f, "%d %d", &N, &P);
	for (i = 1; i <= N; i++) nr[i] = 1;
	for (i = 1; i < N; i++)
	{
		fscanf(f, "%d %d", &I, &J);
		A[I][0]++;
		A[I][A[I][0]] = J;
		nr[J] = 0;
	}
	fclose(f);

	for (i = 1; i <= N; i++)
		if (nr[i])
		{
			R = i;
			break;
		}
}

int k, s, t;
int st[NMax+1];

int Proc(int n)
{
	int i;

	M[n][0] = 1;
	for (i = 1; i <= N; i++) M[n][i] = MAXINT;

	for (i = 1; i <= A[n][0]; i++)
		if (Proc(A[n][i]))
			return 1;

	if (A[n][0] == 0)
	{
		M[n][1] = 0;
	}
	else
	{
		for (i = 1; i <= A[n][0]; i++) st[i] = 0;
		k = A[n][0];
		s = 1;
		t = A[n][0];
		while (k > 0)
		{
			if (st[k] >= 0)
			{
				if ((k == A[n][0]) && (t < M[n][s]))
				{
					if ((*Timer) >= TStop) return 1;
					M[n][s] = t;
					if ((s == P) && (t < Min))
						Min = t;
				}
				t -= M[A[n][k]][st[k]];
			}

			st[k]++;
			s++;
			if (M[A[n][k]][st[k]] < MAXINT)
			{
				t += M[A[n][k]][st[k]];
				if (k < A[n][0])
				{
					k++;
					st[k] = -1;
					s--;
				}
			}
			else
			{
				s -= st[k];
				k--;
			}
		}
	}
	return 0;
}

void WriteData()
{
	FILE* f = fopen("arbore.out", "wt");
	if (M[R][P] < MAXINT)
		fprintf(f, "%d\n", M[R][P]);
	else
		fprintf(f, "%d\n", Min+1);
	fclose(f);
}

void main()
{
	Timer = (long far*)MK_FP(0x0000, 0x046C);
	TStop = (*Timer) + 14;
	Min = MAXINT;

	ReadData();
	Proc(R);
	WriteData();
}