#include <stdio.h>

const int NMax = 20;

int N, L, P, Q, C;
int M[NMax*6+2][NMax*6+2];


void ReadData()
{
	FILE* f = fopen("patrat.in", "rt");
	fscanf(f, "%d", &N); L = 6 * N + 1;
	fscanf(f, "%d %d", &P, &Q);
	fclose(f);
}

void FillLine(int x1)
{
	for (int i = 1; i < L-2; i += 2)
	{
		C++;
		M[x1  ][i  ] = C;
		M[x1  ][i+1] = C;
		M[x1+1][i  ] = C;
		C++;
		M[x1+1][i+1] = C;
		M[x1+2][i  ] = C;
		M[x1+2][i+1] = C;
		C++;
		M[x1+3][i  ] = C;
		M[x1+3][i+1] = C;
		M[x1+4][i  ] = C;
		C++;
		M[x1+4][i+1] = C;
		M[x1+5][i  ] = C;
		M[x1+5][i+1] = C;
	}

	i = L-2;
	for (int j = 0; j < 5; j += 2)
	{
		C++;
		M[x1+j  ][i  ] = C;
		M[x1+j  ][i+1] = C;
		M[x1+j+1][i  ] = C;
		C++;
		M[x1+j  ][i+2] = C;
		M[x1+j+1][i+1] = C;
		M[x1+j+1][i+2] = C;
	}
}

const int SQ[7][6] = {
{1,1,2,3,3,4},
{1,2,2,3,4,4},
{5,5,7,7,9,9},
{5,6,7,8,9,10},
{6,6,8,8,10,10},
{11,11,12,13,13,14},
{11,12,12,13,14,14}};

void FillSquare(int x1, int y1)
{
	for (int i = 0; i < 7; i++)
		for (int j = 0; j < 6; j++)
			M[x1+i][y1+j] = C + SQ[i][j];
	C += 14;
}


int A[7][7] = {
{0,0,0,0,0,9,9},
{0,0,0,0,0,9,10},
{0,0,0,0,0,10,10},
{0,0,0,0,7,7,8},
{1,1,3,3,7,8,8},
{1,2,3,4,5,5,6},
{2,2,4,4,5,6,6}};

int CB[7][7] = {
{1,1,2,2,3,3,4},
{1,5,0,2,3,4,4},
{5,5,6,6,7,7,8},
{9,9,10,6,7,8,8},
{9,10,10,13,13,15,15},
{11,11,12,13,14,15,16},
{11,12,12,14,14,16,16}};

int CC[7][7] = {
{1,1,2,2,3,4,4},
{1,5,2,3,3,4,6},
{5,5,0,7,7,6,6},
{8,8,10,7,11,11,12},
{8,9,10,10,11,12,12},
{13,9,9,14,15,15,16},
{13,13,14,14,15,16,16}};

int CD[7][7] = {
{ 1, 1, 2, 3, 3, 4, 4},
{ 1, 2, 2, 3, 5, 5, 4},
{ 6, 6, 7, 0, 5, 8, 8},
{ 6, 7, 7, 9, 9,12, 8},
{10,10,11,11, 9,12,12},
{10,13,11,14,15,15,16},
{13,13,14,14,15,16,16}};

int S[4][5][7][7] = {
{// linia 0
{{0,1,3,3,4},
 {1,1,3,4,4},
 {2,2,5,6,6},
 {2,5,5,6,0}},
{{1,0,5,5,6},
 {1,1,5,6,6},
 {2,2,3,4,4},
 {2,3,3,4,0}},
{{1,1,0,5,5},
 {1,3,3,6,5},
 {2,3,4,6,6},
 {2,2,4,4,0}},
{{1,1,2,0,3},
 {1,2,2,3,3},
 {4,4,5,6,6},
 {4,5,5,6,0}},
},
{// linia 1
{{1,1,2,2,3},
 {0,1,2,3,3},
 {4,4,5,6,6},
 {4,5,5,6,0}},
{{1,1,2,2,3},
 {1,0,2,3,3},
 {4,5,5,6,6},
 {4,4,5,6,0}},
{{0,0,0,0,0},
 {0,0,0,0,0},
 {0,0,0,0,0},
 {0,0,0,0,0}},
{{1,1,2,3,3},
 {1,2,2,0,3},
 {4,4,5,6,6},
 {4,5,5,6,0}},
},
{// linia 2
{{1,1,2,3,3},
 {1,2,2,3,6},
 {0,4,5,6,6},
 {4,4,5,5,0}},
{{1,1,2,3,3},
 {1,2,2,3,6},
 {4,0,5,6,6},
 {4,4,5,5,0}},
{{0,0,0,0,0},
 {0,0,0,0,0},
 {0,0,0,0,0},
 {0,0,0,0,0}},
{{0,0,0,0,0},
 {0,0,0,0,0},
 {0,0,0,0,0},
 {0,0,0,0,0}},
},
{// linia 3
{{1,1,2,3,3},
 {1,2,2,3,4},
 {5,5,6,4,4},
 {0,5,6,6,0}},
{{1,1,2,3,3},
 {1,2,2,3,4},
 {5,5,6,4,4},
 {5,0,6,6,0}},
{{1,1,2,2,3},
 {1,4,2,3,3},
 {5,4,4,6,6},
 {5,5,0,6,0}},
{{1,1,2,3,3},
 {1,2,2,3,4},
 {5,6,6,4,4},
 {5,5,6,0,0}}}};


void FillGap(int x1, int y1)
{
	int i, j, oi, oj, inci, incj, ii, jj;
	int m[7][7];
	for (i = 0; i < 7; i++)
		for (j = 0; j < 7; j++)
			m[i][j] = 0;

	int p = (P <= x1 + 3) ? P : 8-P; p = p - x1;
	int q = (Q <= y1 + 3) ? Q : 8-Q; q = q - y1;

	if (p == 1 && q == 2)
	{
		for (i = 0; i < 7; i++)
			for (j = 0; j < 7; j++)
				if (CB[i][j])
					m[i][j] = C + CB[i][j];
	}
	else
	if (p == 2 && q == 2)
	{
		for (i = 0; i < 7; i++)
			for (j = 0; j < 7; j++)
				if (CC[i][j])
					m[i][j] = C + CC[i][j];
	}
	else
	if (p == 2 && q == 3)
	{
		for (i = 0; i < 7; i++)
			for (j = 0; j < 7; j++)
				if (CD[i][j])
					m[i][j] = C + CD[i][j];
	}
	else
	{
		for (i = 0; i < 7; i++)
			for (j = 0; j < 7; j++)
				if (A[i][j])
					m[i][j] = C + A[i][j];
		C += 10;

		for (i = 0; i < 7; i++)
			for (j = 0; j < 7; j++)
				if (S[p][q][i][j])
					m[i][j] = C + S[p][q][i][j];
		C += 6;
	}

	if (P <= x1 + 3)
	{
		inci = +1;
		oi = 0;
	}
	else
	{
		inci = -1;
		oi = 6;
	}

	if (Q <= y1 + 3)
	{
		incj = +1;
		oj = 0;
	}
	else
	{
		incj = -1;
		oj = 6;
	}

	for (ii = 0, i = oi; (i >= 0) && (i <= 6); i += inci, ii++)
		for (jj = 0, j = oj; (j >= 0) && (j <= 6); j += incj, jj++)
			M[x1+ii][y1+jj] = m[i][j];
}


void Solve()
{
	int incx, incy, i, j, x1, x2, y1, y2;

	incx = incy = 0;
	for (i = 0; i < N; i++)
	{
		x1 = i * 6 + 1 + incx;
		x2 = i * 6 + 6 + incx;
		if ((P < x1) || (P > x2+1))
		{
			FillLine(x1);
		}
		else
		{
			x2++;
			for (j = 0; j < N; j++)
			{
				y1 = j * 6 + 1 + incy;
				y2 = j * 6 + 6 + incy;
				if ((Q < y1) || (Q > y2+1))
				{
					FillSquare(x1, y1);
				}
				else
				{
					FillGap(x1, y1);
					incy = 1;
				}
			}
			incx = 1;
		}
	}
}

void WriteData()
{
	FILE* f = fopen("patrat.out", "wt");
	for (int i = 1; i <= L; i++)
	{
		for (int j = 1; j <= L; j++)
			fprintf(f, "%d ", M[i][j]);
   	fprintf(f, "\n");
	}
	fclose(f);
}

void main()
{
	ReadData();
	Solve();
	WriteData();
}