{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  Max= 30000;

type List= ^Node;
     Node= Record
             Inf: Integer;
             Next: List;
           end;

     ListVec= Array[0.. 16382] of List;

var
  F, G: Text;
  Cmd: Char;
  Father: Array[1.. Max] of Integer;
  L: Array[0.. 1] of ^ListVec;
  Tmp, P1, P2, P3: Integer;
  P: List;

procedure Add(I, J: Integer);
var P, Q, T: List;
begin
  I:= Father[I];
  J:= Father[J];
  P:= L[I Shr 14]^[I and 16383];
  Q:= L[J Shr 14]^[J and 16383];
  if P= Nil then
  begin
    L[I Shr 14]^[I and 16383]:= Q;
    L[J Shr 14]^[J and 16383]:= Nil;
  end;

  T:= Q;
  While Q<> Nil do
  begin
    Father[Q^. Inf]:= I;
    Q:= Q^. Next;
  end;
  while P^. Next<> Nil do
        P:= P^. Next;
  P^. Next:= T;
  L[J Shr 14]^[J and 16383]:= Nil;
end;

function Command(X: Integer): Integer;
var I, Y: Integer;
    Q: List;
begin
  Y:= X;
  X:= Father[X];
  Q:= L[X Shr 14]^[X and 16383];
  While Q^. Inf<> Y do
        Q:= Q^. Next;
  I:= 0;
  While Q^. Next<> Nil do
  begin
    Inc(I);
    Q:= Q^. Next;
  end;
  Command:= I;
end;

begin
  New(L[0]);
  New(L[1]);

  Assign(F, 'CUBURI.IN');
  Reset(F);
  Assign(G, 'CUBURI.OUT');
  Rewrite(G);

  For P1:= 0 to 16383 do
  begin
    L[0]^[P1]:= Nil;
    L[1]^[P1]:= Nil;
  end;
  For P1:= 1 to Max do
  begin
    Father[P1]:= P1;
    New(L[P1 Shr 14]^[P1 and 16383]);
    L[P1 Shr 14]^[P1 and 16383]^. Inf:= P1;
    L[P1 Shr 14]^[P1 and 16383]^. Next:= Nil;
  end;

  While Not SeekEof(F) do
  begin
    Read(F, Cmd);
    Case Cmd of
'P': begin
       ReadLn(F, P1, P2);
       Add(P1, P2);
     end;
'S': begin
       ReadLn(F, P3);
       WriteLn(G, Command(P3));
     end;
    end;
  end;
  Close(F);
  Close(G);
end.