{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program _2_3_siruri_generare;

const fileout='SIR.VAL';
      MAXN=50;
      MODULO=10000;

type intvect=array[1..MAXN] of integer;

var fout:text;
    nsir,nlast:array[1..MAXN,1..MAXN] of ^intvect;
    i,j,k,n,ll,tot,p:integer;

begin
assign(fout,fileout);
rewrite(fout);

for i:=1 to MAXN do
  for j:=1 to MAXN do
    begin
      new(nsir[i,j]);
      fillchar(nsir[i,j]^,sizeof(intvect),0);
      new(nlast[i,j]);
      fillchar(nlast[i,j]^,sizeof(intvect),0);
    end;

writeln(fout,1);
writeln(fout,4);

for n:=3 to 50 do
  begin

    for i:=1 to n do
      for j:=1 to n do
        begin
          fillchar(nsir[i,j]^,sizeof(intvect),0);

          for k:=i+1 to n do
            nsir[i,j]^[k]:=1;
        end;


    for ll:=4 to n do
      begin
        for i:=1 to n do
          for j:=1 to n do
            begin
              move(nsir[i,j]^,nlast[i,j]^,sizeof(intvect));
              fillchar(nsir[i,j]^,sizeof(intvect),0);
            end;

        for i:=1 to n do
          for j:=1 to n do
            for k:=1 to n do
              if (nlast[i,j]^[k]>0) then
                for p:=1 to n do
                  if (p>i) and (p>j) then
                    nsir[j,k]^[p]:=(nsir[j,k]^[p]+nlast[i,j]^[k]) mod MODULO;
      end;

    tot:=0;
    for i:=1 to n do
      for j:=1 to n do
        for k:=1 to n do
          tot:=(tot+nsir[i,j]^[k]) mod MODULO;

    writeln(fout,tot);

  end;

close(fout);
end.