{$M $4000,0,0 }
Program Verific;
Uses Crt, Dos;

Const MAX = 100;
      Intrare = 'rubik.in';
      Mutari = 'rubik.out';
Type Dim = -1..MAX+2;
     TipElement = ShortInt;
     Tablou = Array[Dim, Dim] Of TipElement;
     Per = -1..1;
Const D : Array[1..5,1..2] Of Per = ((0, 0), (-1, 0), (0, 1), (1,0), (0, -1));

Var TablaJoc : Tablou;
    fin, f2, FisInput, FisDeTest : Text;
    i, j, m, n : Dim;
    Valoare : TipElement;
    Mut : Integer;
    Numar, i1, pozitie : Integer;
    Nume, Linie : String;
    NumeProg : String;
    ora, min, sec, sut : Word;

Procedure Citire;
Begin
    Assign(FisInput,Intrare); Reset(FisInput);
    ReadLn(FisInput, m, n, Valoare);
    For i := 1 To m Do
        Begin
            For j := 1 To n Do Read(FisInput, TablaJoc[i, j]);
            ReadLn(FisInput)
        End;
    Close(FisInput)
End;

Procedure Bordare;
Begin
    For i := -1 To m+2 Do
        For j := 1 To 2 Do
            Begin
                TablaJoc[i, j-2] := 0;
                TablaJoc[i, n+j] := 0
            End;
    For j := 1 To n Do
        For i := 1 To 2 Do
            Begin
                TablaJoc[i-2, j] := 0;
                TablaJoc[m+i, j] := 0
            End
End;

Procedure Joaca;
Var l, c : Dim;
    o : Char;
    NrMutari : Integer;

Function OK : Boolean;
Begin
    OK := True;
    For i := 1 To m Do
        For j := 1 To n Do
            If TablaJoc[i, j] <> Valoare Then
                Begin
                    OK := False;
                    Exit
                End
End;

Procedure FaOperatia(Op: Char; Lin, Col : Dim);
Begin
    Case Op Of
       '+' : For i := 1 To 5 Do Inc(TablaJoc[Lin + d[i, 1], Col + d[i, 2]]);
       '-' : For i := 1 To 5 Do Dec(TablaJoc[Lin + d[i, 1], Col + d[i, 2]]);
    End
End;

Begin
    Assign(FisDeTest, Mutari); Reset(FisDeTest);
    ReadLn(FisDeTest, NrMutari);
    For Mut := 1 To NrMutari Do
        Begin
            ReadLn(FisDeTest, o, l, c);
            If ((o <> '+') And (o <> '-')) Or Not (l In [1..m]) Or Not (c In [1..n]) Then
                Begin
                    WriteLn('OPERATIA INCORECTA sau IESIRE IN DECOR');
                    Halt(1)
                End;
            FaOperatia(o, l, c);
        End;
    Close(FisDeTest);
    If OK Then
        WriteLn('CORECT')
    Else
        WriteLn('INCORECT');
End;

Begin
{    ClrScr;}

     numeprog := paramstr(1);
     pozitie:=pos('.',numeprog);
     if pozitie=0 then numeprog:=numeprog+'.exe';

     nume:= paramstr(2);
     insert('rubik',nume,0);
     nume := nume+'.in';
     assign(fin,nume); reset(fin);
     assign(f2,Intrare); rewrite(f2);

     While Not(Eof(Fin)) Do
         Begin
             ReadLn(Fin, Linie);
             WriteLn(f2, Linie)
         End;
     close (fin);
     close(f2);

     writeln('Programul ruleaza ...');
     settime(0,0,0,0);
     swapvectors;
     exec(numeprog,'');
     swapvectors;
     gettime(ora,min,sec,sut);
     writeln('Timp de executie : ',sec,'.',sut,' secunde');
     writeln('Se analizeaza fisierul de iesire ...');

    Citire;
    Bordare;
    Joaca
End.
