#pragma option -3 -r -Z -O2 -a
#include <stdio.h>

long a[100][4], b[100][4];

#define RADIX	1000000000l

#define ADD(x, y) \
	if((*x += *y) >= RADIX) \
		*x -= RADIX, x[1]++; \
	if((x[1] += y[1]) >= RADIX) \
		x[1] -= RADIX, x[2]++; \
	if((x[2] += y[2]) >= RADIX) \
		x[2] -= RADIX, x[3]++; \
	x[3] += y[3];

int main()
{
	int i, j, n, k;

	fscanf(fopen("exp.in", "r"), "%d%d", &n, &k);
	for(i = 0; i <= k; *b[i++] = 1) ;
	for(j = 2; j < n; j++)
		for(i = k; i; i--) {
			ADD(b[i], a[i])
			ADD(a[i], b[i - 1])
		}
	ADD(a[k], b[k])
	freopen("exp.out", "w", stdout);
	if(a[k][3])
		printf("%ld%09ld%09ld%09ld", a[k][3], a[k][2], a[k][1], *a[k]);
	else if(a[k][2])
		printf("%ld%09ld%09ld", a[k][2], a[k][1], *a[k]);
	else if(a[k][1])
		printf("%ld%09ld", a[k][1], *a[k]);
	else printf("%ld", *a[k]);
	putchar('\n');
	return(0);
}
