//huge mode
//Andras Csaba
#include <stdio.h>
#include <alloc.h>
#include <process.h>

#define filein "exp.in"
#define fileout "exp.out"
#define maxn 105
#define maxk 105

void kezdoertek();
void megold();
void kiir();

int n, k;
long double *a[maxn];

void main() {
  printf("....\n");
  kezdoertek();
  megold();
  kiir();
}


void megold() {
  int q, w, e;

  for (q=0; q<=n; q++)
    for (w=0; w<=k; w++)
      a[q][w]=0;

  for (q=2; q<=n; q++) {
    a[q][0]=1;
    a[q][1]=(((q-2)*(q-1))>>1);
  }

  for (q=2; q<=n; q++)
    for (w=2; w<=k; w++) {
      for (e=w-1; 4<=e; e--) a[q][w]+=a[q-1][e];
      a[q][k]+=a[q][w-1];
    }

}

void kiir() {
  FILE *fout=fopen(fileout, "w");
  long double ossz=0;

  for (int q=0; q<=k; q++) ossz+=a[n][q];

  fprintf(fout, "%.0Lf", ossz);
  fclose(fout);
}

void kezdoertek() {
  FILE *fin=fopen(filein, "r");
  fscanf(fin, "%d%d", &n, &k);
  fclose(fin);

  if (n<k) k=n;

  for (int q=0; q<=n; q++) {
    if (!(a[q]=(long double *)malloc((k+3)*sizeof(long double)))) {
      printf("nomem!!!\n");
      exit(0);
    }
  }

}