//HUGE MODE
#include <stdio.h>
#include <alloc.h>
#include <process.h>

#define filein "arbore.in"
#define fileout "arbore.out"
#define maxn 153

struct eltype {
  int cs;
  eltype *kov;
};

void kezdoertek();
void gyerekszamol(int, int);
void bejar(int, int, int *);
void kiir();

int n, p;
eltype *el[maxn];
int gyerek[maxn];
int mincs=10000;
int folehet[maxn];
unsigned long *time=(unsigned long *)0x46c, timemax;


void main() {
  timemax=*time+16;
  kezdoertek();
  gyerekszamol(1, 0);
  bejar(1, 0, folehet);
  kiir();
}

void gyerekszamol(int a, int apa) {
  for (eltype *seged=el[a]; seged; seged=seged->kov)
    if (seged->cs!=apa) {
      gyerek[a]++;
      gyerekszamol(seged->cs, a);
    }
}

void bejar(int a, int apa, int *lehet) {
  int *gyereklehet=(int *)malloc((p+5)*sizeof(int));
  int q, w;

  for (q=0; q<=p; q++) lehet[q]=10005;

  lehet[1]=apa? gyerek[a]+1: gyerek[a];

  for (eltype *seged=el[a]; seged; seged=seged->kov) {
    if (seged->cs!=apa) {
      bejar(seged->cs, a, gyereklehet);
      for (q=p; q; q--)
	for (w=1; w<q; w++)
	  if (lehet[w]+gyereklehet[q-w]-2<lehet[q])
	    lehet[q]=lehet[w]+gyereklehet[q-w]-2;
    }
  }

  if (lehet[p]<mincs) mincs=lehet[p];

  free(gyereklehet);

  if (timemax<*time) {
    kiir();
    exit(0);
  }
}

void kiir() {
  FILE *fout=fopen(fileout, "w");

  fprintf(fout, "%d", mincs);
  fclose(fout);
}

void kezdoertek() {
  FILE *fin=fopen(filein, "r");
  eltype *seged;
  int a, b;

  fscanf(fin, "%d%d", &n, &p);

  for (int q=1; q<n; q++) {
    fscanf(fin, "%d%d", &a, &b);

    seged=(eltype *)malloc(sizeof(eltype));
    seged->cs=b;
    seged->kov=el[a];
    el[a]=seged;

    seged=(eltype *)malloc(sizeof(eltype));
    seged->cs=a;
    seged->kov=el[b];
    el[b]=seged;
  }

  fclose(fin);
}