#pragma -3 -a -O2 -Z -r
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int n;
long s;

int s0;
int st[52][3];
int stbl[7][7];
int mv[4][2][2] = {
	{{1, 0}, {0, 1}},
	{{1, 0}, {1, 1}},
	{{0, 1}, {1, 1}},
	{{0, 1}, {-1, 1}}};
int sx[4][2] = {{1, 1}, {1, 1}, {1, 1}, {-1, 1}};

int bk_check(int x0, int y0, int k) {
	if(x0 + sx[k][0] < 0 || x0 + sx[k][0] >= 7)
		return 0;
	if(y0 + sx[k][1] < 0 || y0 + sx[k][1] >= 7)
		return 0;

	if(stbl[x0 + mv[k][0][0]][y0 + mv[k][0][1]] || stbl[x0 + mv[k][1][0]][y0 + mv[k][1][1]])
		return 0;
	return 1;
}
void bk_fill(int x0, int y0, int k, int w) {
	stbl[x0][y0] = w;
	stbl[x0 + mv[k][0][0]][y0 + mv[k][0][1]] = w;
	stbl[x0 + mv[k][1][0]][y0 + mv[k][1][1]] = w;
}
void bk_erase(int x0, int y0, int k) {
	stbl[x0][y0] = 0;
	stbl[x0 + mv[k][0][0]][y0 + mv[k][0][1]] = 0;
	stbl[x0 + mv[k][1][0]][y0 + mv[k][1][1]] = 0;
}

void dobkt(int pm, int qm) {
	int x0, y0;
	int x;
	int clvl;

	memset(stbl, 0, sizeof(stbl));

	stbl[pm][qm] = -1;

	st[1][0] = -1;
	clvl = 1;

	x0 = y0 = 0;
	while(1) {
		for(; x0 < 7; x0++)
			if(!stbl[x0][y0])
				break;
		if(!(x0 < 7)) {
			if(++y0 == 7)
				break;
			for(; y0 < 7; y0++) {
				for(x0 = 0; x0 < 7; x0++)
					if(!stbl[x0][y0])
						break;
				if(x0 < 7)
					break;
			}
			if(x0 == 7 && y0 == 7)
				break;
		}
		for(x = st[clvl][0] + 1; x < 4; x++) {
			if(bk_check(x0, y0, x))
				break;
		}
		if(x < 4) {
			st[clvl][0] = x;
			st[clvl][1] = x0;
			st[clvl][2] = y0;
			bk_fill(x0++, y0, x, clvl);
			clvl++;
			st[clvl][0] = -1;
		}
		else {
			clvl--;
			if(!clvl)
      	break;
			x0 = st[clvl][1];
			y0 = st[clvl][2];
			bk_erase(x0, y0, st[clvl][0]);
		}
	}
}

int smod1[7][7] =
	{{1, 1, 2, 2, 3, 3},
	 {1, 4, 2, 5, 3, 6},
	 {4, 4, 5, 5, 6, 6},
	 {7, 7, 8, 8, 9, 9},
	 {7, 10, 8, 11, 9, 12},
	 {10, 10, 11, 11, 12, 12}};
int smod2[7][7] =
	{{1, 1, 5, 5, 9, 9, 10},
	{1, 2, 5, 6, 9, 10, 10},
	{2, 2, 6, 6, 11, 11, 12},
	{3, 3, 7, 7, 11, 12, 12},
	{3, 4, 7, 8, 13, 13, 14},
	{4, 4, 8, 8, 13, 14, 14}};

int smod3[7][7] =
	{{1, 1, 2, 3, 3, 4},
	 {1, 2, 2, 3, 4, 4},
	 {5, 5, 6, 7, 7, 8},
	 {5, 6, 6, 7, 8, 8},
	 {9, 9, 11, 11, 13, 13},
	 {9, 10, 11, 12, 13, 14},
	 {10, 10, 12, 12, 14, 14}};

int ftbl[121][121];
int wl, wm;

void addsol(int solmd[7][7], int sx, int sy, int x0, int y0) {
	int x, y;

	wm = 0;
	for(x = 0; x < sx; x++) {
		for(y = 0; y < sy; y++) {
			if(solmd[x][y] == -1)
				ftbl[x0 + x][y0 + y] = 0;
			else {
				ftbl[x0 + x][y0 + y] = wl + solmd[x][y];
				if(solmd[x][y] > wm)
					wm = solmd[x][y];
			}
		}
	}
	wl += wm;
}

void main() {
	FILE *fp;
	int n, p, q;
	int pm, qm;
	int px, qy;
	int rn;
	int x, y;

	fp = fopen("patrat.in", "rt");
	fscanf(fp, "%d", &n);
	fscanf(fp, "%d %d", &q, &p);
	p--; q--;
	fclose(fp);

	pm = p % 6;
	qm = q % 6;
	px = p - pm;
	qy = q - qm;
	dobkt(pm, qm);

	wm = 0;

	rn = (n << 1) + (n << 2) + 1;
	for(y = 0; y < rn; y += 6) {
		for(x = 0; x < rn; x += 6) {
			if(y == qy && x == px) {
				addsol(stbl, 7, 7, x, y);
        x++;
			}
			else {
				if(y == qy)
					addsol(smod2, 6, 7, x, y);
				else if(x == px) {
					addsol(smod3, 7, 6, x, y);
					x++;
				}
				else
					addsol(smod1, 6, 6, x, y);
			}
		}
		if(y == qy)
			y++;
	}


	fp = fopen("patrat.out", "wt");
	for(y = 0; y < rn; y++) {
		for(x = 0; x < rn; x++)
			fprintf(fp, "%4d ", ftbl[x][y]);
		fprintf(fp, "\n");
  }
	fclose(fp);
}