#include <stdio.h>

const int NMax = 30000;

char Buffer[1<<14];


int  far P[NMax+1];
int  far S[NMax+1];
int  far C[NMax+1];


void Join(int x, int y)
{
	int px = P[x];
	while (px)
	{
		x  = px;
		px = P[x];
	}
	P[x] = S[y];

	int c = C[x] + 1;
	int s = S[x];
	y = S[y];
	while (y)
	{
		C[y] += c;
		S[y]  = s;
		y = P[y];
	}
}

void main()
{
	FILE* fin  = fopen("cuburi.in" , "rt");
	FILE* fout = fopen("cuburi.out", "wt");
	setvbuf(fin, Buffer, _IOFBF, sizeof(Buffer));

	for (int i = 1; i <= NMax; i++) S[i] = i;

	char cop;
	int  x, y;

	do
	{
		fscanf(fin, "%c", &cop);
		switch (cop)
		{
			case 'P':
			{
				fscanf(fin, "%d %d\n", &y, &x);
				Join(x, y);
			} break;
			case 'S':
			{
				fscanf(fin, "%d %d\n", &x);
				fprintf(fout, "%d\n", C[x]);
			} break;
		}
	} while (!feof(fin));

	fclose(fout);
	fclose(fin);
}
